Index: /code/branches/gamestates2/src/libraries/core/GUIManager.h
===================================================================
--- /code/branches/gamestates2/src/libraries/core/GUIManager.h	(revision 6594)
+++ /code/branches/gamestates2/src/libraries/core/GUIManager.h	(revision 6595)
@@ -41,6 +41,12 @@
 
 #include "util/OgreForwardRefs.h"
+#include "util/TriBool.h"
 #include "util/Singleton.h"
 #include "input/InputHandler.h"
+
+// Tolua includes (have to be relative to the current directory)
+/*
+$cfile "../util/TriBool.h" // tolua_export
+*/
 
 namespace orxonox // tolua_export
@@ -54,5 +60,4 @@
 
         The GUIManager is a singleton and can be called anywhere when access on the GUI is needed.
-        Creation of the GUIManager is therefore not possible and the cunstructor is private.
 
         Since the GUI needs user input, the GUIManager implements the functions needed to act as a key and/or mouse handler.
@@ -64,9 +69,10 @@
         friend class Singleton<GUIManager>;
     public:
-        GUIManager(Ogre::RenderWindow* renderWindow, const std::pair<int, int>& mousePosition, bool bFullScreen);
+        GUIManager(const std::pair<int, int>& mousePosition);
         ~GUIManager();
 
         void preUpdate(const Clock& time);
 
+        void loadGUI(const std::string& name);
         static void showGUI(const std::string& name, bool hidePrevious=false, bool showCursor=true);
         void showGUIExtra(const std::string& name, const std::string& ptr, bool hidePrevious=false, bool showCursor=true);
@@ -75,8 +81,8 @@
         void setBackground(const std::string& name);
 
+        const std::string& createInputState(const std::string& name, TriBool::Value showMouse = TriBool::True, TriBool::Value useKeyboard = TriBool::True, bool bBlockJoyStick = false); // tolua_export
+
         void setCamera(Ogre::Camera* camera);
         Ogre::Camera* getCamera() { return this->camera_; }
-
-        static GUIManager* getInstancePtr() { return singletonPtr_s; }
 
         inline void setPlayer(const std::string& guiname, PlayerInfo* player)
@@ -87,4 +93,6 @@
         // TODO: Temporary hack because the tolua exported CEGUI method does not seem to work
         static void subscribeEventHelper(CEGUI::Window* window, const std::string& event, const std::string& function); //tolua_export
+
+        static GUIManager& getInstance() { return Singleton<GUIManager>::getInstance(); } // tolua_export
 
     private:
@@ -102,5 +110,4 @@
         void mouseMoved    (IntVector2 abs, IntVector2 rel, IntVector2 clippingSize);
         void mouseScrolled (int abs, int rel);
-
         scoped_ptr<CEGUI::OgreCEGUIRenderer> guiRenderer_;      //!< CEGUI's interface to the Ogre Engine
         scoped_ptr<LuaState>                 luaState_;         //!< LuaState, access point to the Lua engine
@@ -108,12 +115,10 @@
         scoped_ptr<CEGUI::System>            guiSystem_;        //!< CEGUI's main system
         shared_ptr<ResourceInfo>             rootFileInfo_;     //!< Resource information about the root script
-        Ogre::RenderWindow*                  renderWindow_;     //!< Ogre's render window to give CEGUI access to it
         CEGUI::ResourceProvider*             resourceProvider_; //!< CEGUI's resource provider
         CEGUI::Logger*                       ceguiLogger_;      //!< CEGUI's logger to be able to log CEGUI errors in our log
-        std::map<std::string, PlayerInfo*>   players_;          //!< Stores the player (owner) for each gui
+        std::map<std::string, PlayerInfo*>   players_;          //!< Stores the player (owner) for each GUI
         Ogre::Camera*                        camera_;           //!< Camera used to render the scene with the GUI
 
         static GUIManager*                   singletonPtr_s;    //!< Singleton reference to GUIManager
-        bool                                 bShowIngameGUI_;
 
     }; // tolua_export
Index: /code/branches/gamestates2/src/libraries/core/Game.h
===================================================================
--- /code/branches/gamestates2/src/libraries/core/Game.h	(revision 6594)
+++ /code/branches/gamestates2/src/libraries/core/Game.h	(revision 6595)
@@ -50,5 +50,5 @@
 #include "util/ScopeGuard.h"
 #include "util/Singleton.h"
-#include "core/OrxonoxClass.h"
+#include "OrxonoxClass.h"
 
 /**
Index: /code/branches/gamestates2/src/libraries/core/IOConsole.cc
===================================================================
--- /code/branches/gamestates2/src/libraries/core/IOConsole.cc	(revision 6594)
+++ /code/branches/gamestates2/src/libraries/core/IOConsole.cc	(revision 6595)
@@ -35,6 +35,6 @@
 #include "util/Clock.h"
 #include "util/Math.h"
-#include "core/Game.h"
-#include "core/input/InputBuffer.h"
+#include "Game.h"
+#include "input/InputBuffer.h"
 
 // ##########################
Index: /code/branches/gamestates2/src/libraries/core/IOConsole.h
===================================================================
--- /code/branches/gamestates2/src/libraries/core/IOConsole.h	(revision 6594)
+++ /code/branches/gamestates2/src/libraries/core/IOConsole.h	(revision 6595)
@@ -37,5 +37,5 @@
 #include <vector>
 #include "util/Singleton.h"
-#include "core/Shell.h"
+#include "Shell.h"
 
 #ifdef ORXONOX_PLATFORM_UNIX
Index: /code/branches/gamestates2/src/libraries/core/LuaState.h
===================================================================
--- /code/branches/gamestates2/src/libraries/core/LuaState.h	(revision 6594)
+++ /code/branches/gamestates2/src/libraries/core/LuaState.h	(revision 6595)
@@ -40,5 +40,5 @@
 
 #include "util/ScopeGuard.h"
-#include "core/Functor.h"
+#include "Functor.h"
 #include "ToluaInterface.h"
 
Index: /code/branches/gamestates2/src/libraries/core/Template.cc
===================================================================
--- /code/branches/gamestates2/src/libraries/core/Template.cc	(revision 6594)
+++ /code/branches/gamestates2/src/libraries/core/Template.cc	(revision 6595)
@@ -33,6 +33,6 @@
 
 #include "util/Debug.h"
-#include "core/CoreIncludes.h"
-#include "core/XMLPort.h"
+#include "CoreIncludes.h"
+#include "XMLPort.h"
 
 namespace orxonox
Index: /code/branches/gamestates2/src/libraries/core/input/InputManager.cc
===================================================================
--- /code/branches/gamestates2/src/libraries/core/input/InputManager.cc	(revision 6594)
+++ /code/branches/gamestates2/src/libraries/core/input/InputManager.cc	(revision 6595)
@@ -87,5 +87,5 @@
         , oisInputManager_(0)
         , devices_(2)
-        , mouseMode_(MouseMode::Nonexclusive)
+        , exclusiveMouse_(TriBool::False)
         , emptyState_(0)
         , calibratorCallbackHandler_(0)
@@ -98,5 +98,5 @@
 
         if (GraphicsManager::getInstance().isFullScreen())
-            mouseMode_ = MouseMode::Exclusive;
+            exclusiveMouse_ = TriBool::True;
         this->loadDevices();
 
@@ -155,5 +155,5 @@
         paramList.insert(std::make_pair("w32_keyboard", "DISCL_FOREGROUND"));
         paramList.insert(std::make_pair("w32_mouse", "DISCL_FOREGROUND"));
-        if (mouseMode_ == MouseMode::Exclusive || GraphicsManager::getInstance().isFullScreen())
+        if (exclusiveMouse_ == TriBool::True || GraphicsManager::getInstance().isFullScreen())
         {
             // Disable Windows key plus special keys (like play, stop, next, etc.)
@@ -168,5 +168,5 @@
         paramList.insert(std::make_pair("XAutoRepeatOn", "true"));
 
-        if (mouseMode_ == MouseMode::Exclusive || GraphicsManager::getInstance().isFullScreen())
+        if (exclusiveMouse_ == TriBool::True || GraphicsManager::getInstance().isFullScreen())
         {
             if (CommandLineParser::getValue("keyboard_no_grab").getBool())
@@ -504,13 +504,13 @@
 
         // Check whether we have to change the mouse mode
-        MouseMode::Value requestedMode = MouseMode::Dontcare;
+        TriBool::Value requestedMode = TriBool::Dontcare;
         std::vector<InputState*>& mouseStates = devices_[InputDeviceEnumerator::Mouse]->getStateListRef();
         if (mouseStates.empty())
-            requestedMode = MouseMode::Nonexclusive;
+            requestedMode = TriBool::False;
         else
-            requestedMode = mouseStates.front()->getMouseMode();
-        if (requestedMode != MouseMode::Dontcare && mouseMode_ != requestedMode)
-        {
-            mouseMode_ = requestedMode;
+            requestedMode = mouseStates.front()->getMouseExclusive();
+        if (requestedMode != TriBool::Dontcare && exclusiveMouse_ != requestedMode)
+        {
+            exclusiveMouse_ = requestedMode;
             if (!GraphicsManager::getInstance().isFullScreen())
                 this->reloadInternal();
Index: /code/branches/gamestates2/src/libraries/core/input/InputManager.h
===================================================================
--- /code/branches/gamestates2/src/libraries/core/input/InputManager.h	(revision 6594)
+++ /code/branches/gamestates2/src/libraries/core/input/InputManager.h	(revision 6595)
@@ -38,4 +38,5 @@
 
 #include "util/Singleton.h"
+#include "util/TriBool.h"
 #include "core/WindowEventListener.h"
 #include "InputState.h"
@@ -159,5 +160,5 @@
             - The removal process is being postponed if InputManager::preUpdate() is currently running.
         */
-        bool destroyState(const std::string& name);
+        bool destroyState(const std::string& name); // tolua_export
 
         //-------------------------------
@@ -196,5 +197,5 @@
         OIS::InputManager*                  oisInputManager_;      //!< OIS input manager
         std::vector<InputDevice*>           devices_;              //!< List of all input devices (keyboard, mouse, joy sticks)
-        MouseMode::Value                    mouseMode_;            //!< Currently applied mouse mode
+        TriBool::Value                      exclusiveMouse_;       //!< Currently applied mouse mode
 
         // some internally handled states and handlers
Index: /code/branches/gamestates2/src/libraries/core/input/InputState.cc
===================================================================
--- /code/branches/gamestates2/src/libraries/core/input/InputState.cc	(revision 6594)
+++ /code/branches/gamestates2/src/libraries/core/input/InputState.cc	(revision 6595)
@@ -37,5 +37,5 @@
         , bAlwaysGetsInput_(bAlwaysGetsInput)
         , bTransparent_(bTransparent)
-        , mouseMode_(MouseMode::Dontcare)
+        , exclusiveMouse_(TriBool::Dontcare)
         , bExpired_(true)
         , handlers_(2)
Index: /code/branches/gamestates2/src/libraries/core/input/InputState.h
===================================================================
--- /code/branches/gamestates2/src/libraries/core/input/InputState.h	(revision 6594)
+++ /code/branches/gamestates2/src/libraries/core/input/InputState.h	(revision 6595)
@@ -37,4 +37,5 @@
 
 #include "util/OrxEnum.h"
+#include "util/TriBool.h"
 #include "InputHandler.h"
 #include "JoyStickQuantityListener.h"
@@ -56,13 +57,4 @@
     };
 
-    namespace MouseMode
-    {
-        enum Value
-        {
-            Exclusive,
-            Nonexclusive,
-            Dontcare
-        };
-    }
 
     /**
@@ -73,5 +65,5 @@
         that stack and only the top one gets the input events. This is done for
         every device (keyboard, mouse, all joy sticks) separately to allow
-        for intance keyboard input capturing for the console while you can still
+        for instance keyboard input capturing for the console while you can still
         steer a ship with the mouse.
         There are two exceptions to this behaviour though:
@@ -83,5 +75,5 @@
           the state will always receive input as long as it is activated.
         - Note: If you mark an InputState with both parameters on, then it will
-          not influence ony other InputState at all.
+          not influence only other InputState at all.
 
     @par Priorities
@@ -95,5 +87,5 @@
     @par Exclusive/Non-Exclusive mouse Mode
         You can select a specific mouse mode that tells whether the application
-        should have exclusive accessto it or not.
+        should have exclusive access to it or not.
         When in non-exclusive mode, you can move the mouse out of the window
         like with any other normal window (only for windowed mode!).
@@ -130,6 +122,6 @@
         void setHandler        (InputHandler* handler);
 
-        void setMouseMode(MouseMode::Value value) { mouseMode_ = value; this->bExpired_ = true; }
-        MouseMode::Value getMouseMode() const { return mouseMode_; }
+        void setMouseExclusive(TriBool::Value value) { exclusiveMouse_ = value; this->bExpired_ = true; }
+        TriBool::Value getMouseExclusive() const { return exclusiveMouse_; }
 
         //! Returns the name of the state (which is unique!)
@@ -184,5 +176,5 @@
         const bool                  bAlwaysGetsInput_;      //!< See class declaration for explanation
         const bool                  bTransparent_;          //!< See class declaration for explanation
-        MouseMode::Value            mouseMode_;             //!< See class declaration for explanation
+        TriBool::Value              exclusiveMouse_;        //!< See class declaration for explanation
         int                         priority_;              //!< Current priority (might change)
         bool                        bExpired_;              //!< See hasExpired()
Index: /code/branches/gamestates2/src/libraries/network/TrafficControl.h
===================================================================
--- /code/branches/gamestates2/src/libraries/network/TrafficControl.h	(revision 6594)
+++ /code/branches/gamestates2/src/libraries/network/TrafficControl.h	(revision 6595)
@@ -34,5 +34,5 @@
 #include <list>
 #include <map>
-#include "network/ClientConnectionListener.h"
+#include "ClientConnectionListener.h"
 
 namespace orxonox {
Index: /code/branches/gamestates2/src/libraries/util/Serialise.h
===================================================================
--- /code/branches/gamestates2/src/libraries/util/Serialise.h	(revision 6594)
+++ /code/branches/gamestates2/src/libraries/util/Serialise.h	(revision 6595)
@@ -35,7 +35,9 @@
 #define _Serialise_H__
 
+#include "UtilPrereqs.h"
+
 #include <cstring>
-#include "util/Math.h"
-#include "util/mbool.h"
+#include "Math.h"
+#include "mbool.h"
 
 namespace orxonox{
Index: /code/branches/gamestates2/src/libraries/util/TriBool.h
===================================================================
--- /code/branches/gamestates2/src/libraries/util/TriBool.h	(revision 6595)
+++ /code/branches/gamestates2/src/libraries/util/TriBool.h	(revision 6595)
@@ -0,0 +1,49 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _TriBool_H__
+#define _TriBool_H__
+
+#include "UtilPrereqs.h"
+
+// tolua_begin
+namespace orxonox
+{
+    namespace TriBool
+    {
+        enum Value
+        {
+            False    =  0,
+            True     =  1,
+            Dontcare =  2
+        };
+    }
+}
+// tolua_end
+
+#endif /* _TriBool_H__ */
Index: /code/branches/gamestates2/src/modules/questsystem/QuestGUI.cc
===================================================================
--- /code/branches/gamestates2/src/modules/questsystem/QuestGUI.cc	(revision 6594)
+++ /code/branches/gamestates2/src/modules/questsystem/QuestGUI.cc	(revision 6595)
@@ -109,5 +109,5 @@
 
         //! Create root window.
-        this->rootWindow_ = this->windowManager_->createWindow("TaharezLook/ScrollablePane", "QuestGUI/Quests");
+        this->rootWindow_ = this->windowManager_->createWindow("MenuWidgets/ScrollablePane", "QuestGUI/Quests");
         this->rootWindow_->setSize(CEGUI::UVector2(CEGUI::UDim(1, 0),CEGUI::UDim(1, 0)));
 
@@ -161,7 +161,7 @@
         Get a CEGUI Window to use.
         Windows that are no longer used are collected with giveWindow, and are given out again with getWindow, so save some time recreating new windows everytime.
-        The retreived window is of type "TaharezLook/TabButton".
-    @return
-        Returns a CEGUI Window of type "TaharezLook/TabButton".
+        The retreived window is of type "MenuWidgets/TabButton".
+    @return
+        Returns a CEGUI Window of type "MenuWidgets/TabButton".
     */
     CEGUI::Window* QuestGUI::getWindow(void)
@@ -177,5 +177,5 @@
         std::ostringstream stream;
         stream << "QuestGUI/Quests/EmptyWindows/" << this->windows_.size()+1;
-        return this->windowManager_->createWindow("TaharezLook/TabButton", stream.str());
+        return this->windowManager_->createWindow("MenuWidgets/TabButton", stream.str());
     }
 
Index: /code/branches/gamestates2/src/modules/questsystem/QuestGUINode.cc
===================================================================
--- /code/branches/gamestates2/src/modules/questsystem/QuestGUINode.cc	(revision 6594)
+++ /code/branches/gamestates2/src/modules/questsystem/QuestGUINode.cc	(revision 6595)
@@ -160,5 +160,5 @@
             stream << this->window_->getName() << "/Details";
             const QuestDescription* description = this->item_->getDescription();
-            this->details_ = this->gui_->getWindowManager()->createWindow("TaharezLook/FrameWindow", stream.str());
+            this->details_ = this->gui_->getWindowManager()->createWindow("MenuWidgets/FrameWindow", stream.str());
             this->details_->setSize(CEGUI::UVector2(CEGUI::UDim(0.7f, 0),CEGUI::UDim(0.7f, 0)));
             this->details_->setPosition(CEGUI::UVector2(CEGUI::UDim(0.1f, 0),CEGUI::UDim(0.1f, 0)));
@@ -171,5 +171,5 @@
             //! Create a ScrollablePane.
             stream << "/Scrollable";
-            CEGUI::Window* window = this->gui_->getWindowManager()->createWindow("TaharezLook/ScrollablePane", stream.str());
+            CEGUI::Window* window = this->gui_->getWindowManager()->createWindow("MenuWidgets/ScrollablePane", stream.str());
             window->setSize(CEGUI::UVector2(CEGUI::UDim(1.0, -2*QuestGUINode::BORDER_WIDTH),CEGUI::UDim(1.0, -QuestGUINode::TITLE_HEIGHT)));
             window->setPosition(CEGUI::UVector2(CEGUI::UDim(0, (float)QuestGUINode::BORDER_WIDTH),CEGUI::UDim(0, (float)QuestGUINode::TITLE_HEIGHT)));
@@ -185,5 +185,5 @@
                 stream.str("");
                 stream << this->details_->getName() << "/Status";
-                CEGUI::Window* statusWindow = this->gui_->getWindowManager()->createWindow("TaharezLook/StaticText", stream.str());
+                CEGUI::Window* statusWindow = this->gui_->getWindowManager()->createWindow("MenuWidgets/StaticText", stream.str());
                 window->addChildWindow(statusWindow);
                 std::string status;
@@ -214,5 +214,5 @@
             stream << this->details_->getName() << "/Description";
             stream << "/Title";
-            CEGUI::Window* descriptionWindowTitle = this->gui_->getWindowManager()->createWindow("TaharezLook/StaticText", stream.str());
+            CEGUI::Window* descriptionWindowTitle = this->gui_->getWindowManager()->createWindow("MenuWidgets/StaticText", stream.str());
             window->addChildWindow(descriptionWindowTitle);
             descriptionWindowTitle->setProperty("HorzFormatting", "HorzCentred");
@@ -227,5 +227,5 @@
             stream.str("");
             stream << this->details_->getName() << "/Description";
-            CEGUI::Window* descriptionWindow = this->gui_->getWindowManager()->createWindow("TaharezLook/StaticText", stream.str());
+            CEGUI::Window* descriptionWindow = this->gui_->getWindowManager()->createWindow("MenuWidgets/StaticText", stream.str());
             window->addChildWindow(descriptionWindow);
             descriptionWindow->setProperty("HorzFormatting", "WordWrapLeftAligned");
@@ -250,5 +250,5 @@
                             stream.str("");
                             stream << this->details_->getName() << "/Hints/Title";
-                            CEGUI::Window* hintsTitle = this->gui_->getWindowManager()->createWindow("TaharezLook/StaticText", stream.str());
+                            CEGUI::Window* hintsTitle = this->gui_->getWindowManager()->createWindow("MenuWidgets/StaticText", stream.str());
                             window->addChildWindow(hintsTitle);
                             hintsTitle->setProperty("HorzFormatting", "HorzCentred");
Index: /code/branches/gamestates2/src/orxonox/gamestates/GSLevel.cc
===================================================================
--- /code/branches/gamestates2/src/orxonox/gamestates/GSLevel.cc	(revision 6594)
+++ /code/branches/gamestates2/src/orxonox/gamestates/GSLevel.cc	(revision 6595)
@@ -69,14 +69,14 @@
         {
             gameInputState_ = InputManager::getInstance().createInputState("game");
-            gameInputState_->setMouseMode(MouseMode::Exclusive);
+            gameInputState_->setMouseExclusive(TriBool::True);
             gameInputState_->setHandler(KeyBinderManager::getInstance().getDefaultAsHandler());
             KeyBinderManager::getInstance().setToDefault();
 
             guiMouseOnlyInputState_ = InputManager::getInstance().createInputState("guiMouseOnly");
-            guiMouseOnlyInputState_->setMouseMode(MouseMode::Exclusive);
-            guiMouseOnlyInputState_->setMouseHandler(GUIManager::getInstancePtr());
+            guiMouseOnlyInputState_->setMouseExclusive(TriBool::True);
+            guiMouseOnlyInputState_->setMouseHandler(&GUIManager::getInstance());
 
             guiKeysOnlyInputState_ = InputManager::getInstance().createInputState("guiKeysOnly");
-            guiKeysOnlyInputState_->setKeyHandler(GUIManager::getInstancePtr());
+            guiKeysOnlyInputState_->setKeyHandler(&GUIManager::getInstance());
         }
 
Index: /code/branches/gamestates2/src/orxonox/gamestates/GSMainMenu.cc
===================================================================
--- /code/branches/gamestates2/src/orxonox/gamestates/GSMainMenu.cc	(revision 6594)
+++ /code/branches/gamestates2/src/orxonox/gamestates/GSMainMenu.cc	(revision 6595)
@@ -53,6 +53,6 @@
         RegisterRootObject(GSMainMenu);
         inputState_ = InputManager::getInstance().createInputState("mainMenu");
-        inputState_->setMouseMode(MouseMode::Nonexclusive);
-        inputState_->setHandler(GUIManager::getInstancePtr());
+        inputState_->setMouseExclusive(TriBool::False);
+        inputState_->setHandler(&GUIManager::getInstance());
         inputState_->setKeyHandler(KeyBinderManager::getInstance().getDefaultAsHandler());
         inputState_->setJoyStickHandler(&InputHandler::EMPTY);
@@ -101,5 +101,5 @@
 
         KeyBinderManager::getInstance().setToDefault();
-        InputManager::getInstance().enterState("mainMenu");
+        //InputManager::getInstance().enterState("mainMenu");
 
         this->setConfigValues();
@@ -119,5 +119,5 @@
         }
 
-        InputManager::getInstance().leaveState("mainMenu");
+        //InputManager::getInstance().leaveState("mainMenu");
 
         GUIManager::getInstance().setCamera(0);
Index: /code/branches/gamestates2/src/orxonox/overlays/CMakeLists.txt
===================================================================
--- /code/branches/gamestates2/src/orxonox/overlays/CMakeLists.txt	(revision 6594)
+++ /code/branches/gamestates2/src/orxonox/overlays/CMakeLists.txt	(revision 6595)
@@ -1,3 +1,4 @@
 ADD_SOURCE_FILES(ORXONOX_SRC_FILES
+  GUISheet.cc
   OrxonoxOverlay.cc
   OverlayGroup.cc
Index: /code/branches/gamestates2/src/orxonox/overlays/GUISheet.cc
===================================================================
--- /code/branches/gamestates2/src/orxonox/overlays/GUISheet.cc	(revision 6595)
+++ /code/branches/gamestates2/src/orxonox/overlays/GUISheet.cc	(revision 6595)
@@ -0,0 +1,94 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "GUISheet.h"
+
+#include "core/CoreIncludes.h"
+#include "core/GUIManager.h"
+#include "core/XMLPort.h"
+
+namespace orxonox
+{
+    CreateFactory(GUISheet);
+
+    GUISheet::GUISheet(BaseObject* creator)
+        : BaseObject(creator)
+        , bShowOnLoad_(false)
+        , bShowCursor_(true)
+        , bHidePrevious_(false)
+    {
+        RegisterObject(GUISheet);
+
+        if (!GameMode::showsGraphics())
+            ThrowException(NoGraphics, "GUISheet construction failed: no graphics");
+    }
+
+    GUISheet::~GUISheet()
+    {
+    }
+
+    void GUISheet::XMLPort(Element& xmlElement, XMLPort::Mode mode)
+    {
+        SUPER(GUISheet, XMLPort, xmlElement, mode);
+
+        XMLPortParam(GUISheet, "showOnLoad",   setShowOnLoad,       getShowOnLoad,       xmlElement, mode);
+        XMLPortParam(GUISheet, "showCursor",   setCursorVisibility, getCursorVisibility, xmlElement, mode);
+        XMLPortParam(GUISheet, "hidePrevious", setPreviousHiding,   getPreviousHiding,   xmlElement, mode);
+        XMLPortParam(GUISheet, "script",       setScript,           getScript,           xmlElement, mode);
+    }
+
+    void GUISheet::show()
+    {
+        GUIManager::showGUI(this->script_, this->bHidePrevious_, this->bShowCursor_);
+    }
+
+    void GUISheet::hide()
+    {
+        GUIManager::hideGUI(this->script_);
+    }
+
+    void GUISheet::setScript(const std::string& filename)
+    {
+        this->script_ = filename;
+        GUIManager::getInstance().loadGUI(this->script_);
+        if (this->bShowOnLoad_)
+            this->show();
+    }
+
+    void GUISheet::setCursorVisibility(bool bShow)
+    {
+        this->bShowCursor_ = bShow;
+        // TODO: This call has no effect when already showing!
+    }
+
+    void GUISheet::setPreviousHiding(bool bHide)
+    {
+        this->bHidePrevious_ = bHide;
+        // TODO: This call has no effect when already showing!
+    }
+}
Index: /code/branches/gamestates2/src/orxonox/overlays/GUISheet.h
===================================================================
--- /code/branches/gamestates2/src/orxonox/overlays/GUISheet.h	(revision 6595)
+++ /code/branches/gamestates2/src/orxonox/overlays/GUISheet.h	(revision 6595)
@@ -0,0 +1,76 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _GUISheet_H__
+#define _GUISheet_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include <string>
+#include "core/BaseObject.h"
+
+namespace orxonox
+{
+    //! Simple XML loadable interface to the otherwise Lua coded GUI framework.
+    class _OrxonoxExport GUISheet : public BaseObject
+    {
+    public:
+        GUISheet(BaseObject* creator);
+        ~GUISheet();
+
+        void XMLPort(Element& xmlElement, XMLPort::Mode mode);
+
+        void show();
+        void hide();
+
+        void setScript(const std::string& filename);
+        inline const std::string& getScript() const
+            { return this->script_; }
+
+        inline void setShowOnLoad(bool bShow)
+            { this->bShowOnLoad_ = bShow; }
+        inline bool getShowOnLoad() const
+            { return this->bShowOnLoad_; }
+
+        void setCursorVisibility(bool bShow);
+        inline bool getCursorVisibility() const
+            { return this->bShowCursor_; }
+
+        void setPreviousHiding(bool bHide);
+        inline bool getPreviousHiding() const
+            { return this->bHidePrevious_; }
+
+    private:
+        std::string script_;
+        bool bShowOnLoad_;
+        bool bShowCursor_;
+        bool bHidePrevious_;
+  };
+}
+
+#endif /* _GUISheet_H__ */
